-- ================================================
-- Template generated from Template Explorer using:
-- Create Procedure (New Menu).SQL
--
-- Use the Specify Values for Template Parameters 
-- command (Ctrl-Shift-M) to fill in the parameter 
-- values below.
--
-- This block of comments will not be included in
-- the definition of the procedure.
-- ================================================
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
-- =============================================
-- Author:		Erhard Rainer
-- Create date: 2014-12-13
-- Description:	Search for a certain columnname
-- =============================================
-- exec [dbo].[usp_SearchColumn] @columnname = 'class' , @exact = 1
-- exec [dbo].[usp_SearchColumn] @columnname = 'class' , @exact = 1, @type = 'int'
ALTER PROCEDURE [dbo].[usp_SearchColumn]
	 @columnName as nvarchar(MAX) = null,
	 @exact as bit = 1,
	 @type as nvarchar(100) = null
AS
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;

	Select 
		OBJECT_SCHEMA_NAME(o.object_id) as [Schema], 
		OBJECT_NAME(o.object_id) as [ObjectName],
		c.name as [Column],  
		st.name as [columnType]
		from sys.objects as o
		inner join sys.columns as c
		on o.object_id = c.object_id
		inner join sys.systypes as st
		on st.xtype = c.system_type_id
		Where 
			((@exact= 0 and c.name like '%' + @columnName +'%') or 
			(@exact=1 and c.name = @columnName))
		and 
			((@type is not null and st.name like '%' + @type + '%') or 
			(@type is null))
END
GO
